//* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/*
 * Copyright (c) 1997 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the Computer Systems
 *	Engineering Group at Lawrence Berkeley Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
#undef NDEBUG
#include <assert.h>
#include "delay.h"
#include "connector.h"
#include "packet.h"
#include "random.h"
#include "mobilenode.h"
#include "stream.h"

#include "arp.h"
//#include "ll.h"
//#include "mac.h"
#include "mac-timers_802_11e.h"
#include "mac-802_11e.h"
#include "cmu-trace.h"
#include "priq.h"

//include the following line when using Akaroa
//#include "akaroa.H"
#define AKAROA 0 
#define AK_INTERVAL 0.01 


#define Tianji_Li_DEBUG_0


static double 	    ThruAP0;
static double 	    ThruAP1;
static double 	    ThruAP2;
static double 	    ThruAP3;
static double 	    ThruAP4;
static double 	    ThruAP5;
static double 	    ThruAP6;
static double 	    ThruAP7;
static double 	    ThruAP8;
static double 	    ThruAP9;
static double 	    ThruAP10;
static double 	    ThruAP11;
static double 	    ThruAP12;
static double 	    ThruAP13;
static double 	    ThruAP14;
static double 	    ThruAP15;
static double 	    ThruAP16;
static double 	    ThruAP17;
static double 	    ThruAP18;
static double 	    ThruAP19;


static int      NumAP0;
static int      NumAP1;
static int      NumAP2;
static int      NumAP3;
static int      NumAP4;
static int      NumAP5;
static int      NumAP6;
static int      NumAP7;
static int      NumAP8;
static int      NumAP9;
static int      NumAP10;
static int      NumAP11;
static int      NumAP12;
static int      NumAP13;
static int      NumAP14;
static int      NumAP15;
static int      NumAP16;
static int      NumAP17;
static int      NumAP18;
static int      NumAP19;
static int      NumFromNode0;
static int      NumFromNode1;
static int      NumFromNode2;
static int      NumFromNode3;
static int      NumFromNode4;
static int      NumFromNode5;
static int      NumFromNode6;
static int      NumFromNode7;
static int      NumFromNode8;
static int      NumFromNode9;
static int      NumFromNode10;
static int      NumFromNode11;
static int      NumFromNode12;
static int      NumFromNode13;
static int      NumFromNode14;
static int      NumFromNode15;
static int      NumFromNode16;
static int      NumFromNode17;
static int      NumFromNode18;
static int      NumFromNode19;


static int      Ns;
static int      Nc;
static int      Ni;
static double   TT;
static double   Ts;
static double   TTs;
static double   TTc;
static double   Ti;
static double   Ri;
static double   Rb;
static double   Rs;

int    num_pkt_arrived;
double prev_serv_time;
FILE *file_handler_mac = fopen("outgoing.interval.txt", "w+");
FILE *file_handler_sta = fopen("stations.interval.txt", "w+");
int    ltj_retry_count;
// double RealDrainTime;


inline void
Mac802_11e::set_rx_state(MacState x)
{
	rx_state_ = x;
	check_backoff_timer();
}

inline void
Mac802_11e::set_tx_state(int pri, MacState x)
{
	tx_state_[pri] = x;
}

inline void
Mac802_11e::transmit(Packet *p, double t)
{                                                                       
	/*                                                              
         * If I'm transmitting without doing CS, such as when           
         * sending an ACK, any incoming packet will be "missed"         
         * and hence, must be discarded.                                
         */                                                             
         if(rx_state_ != MAC_IDLE) {                                     
                struct hdr_mac802_11e *dh = HDR_MAC802_11E(p);            
                                                                        
                assert(dh->dh_fc.fc_type == MAC_Type_Control);          
                assert(dh->dh_fc.fc_subtype == MAC_Subtype_ACK);        
                                                                        
                assert(pktRx_);                                         
                struct hdr_cmn *ch = HDR_CMN(pktRx_);                   
                                                                        
                ch->error() = 1;        /* force packet discard */      
        }                                                               
                                                                        
        /*                                                              
         * pass the packet on the "interface" which will in turn        
         * place the packet on the channel.                             
         *                                                              
         * NOTE: a handler is passed along so that the Network          
         *       Interface can distinguish between incoming and         
         *       outgoing packets.                                      
         */
	struct hdr_cmn *sd = HDR_CMN(p);
	int prio = LEVEL(p);
	tx_active_ = 1;
	sending = 1;
	check_backoff_timer();


	// Assing src index manually
	// Tianji Li: 10/10/2006

	if ( sd->ipsrc() == -1 )  sd->ipsrc() = index_;

	downtarget_->recv(p->copy(), this);
	if(sd->ptype() == PT_CBR || sd->ptype() == PT_EXP) {
	  if(!rtx_[prio]){
	    numbytes_[prio] += sd->size() - phymib_.getHdrLen11();
	  }
	} 
	mhIF_.start(txtime(p));  
	mhSend_.start(t);                      

	                                       
} 

void 
Mac802_11e::check_backoff_timer()
{
	if(is_idle() && mhBackoff_.paused()) {
            mhBackoff_.resume();
	}                                   
	if(! is_idle() && mhBackoff_.busy() && ! mhBackoff_.paused()){  
		mhBackoff_.pause();				       
        }                            
 if(!is_idle() && mhDefer_.busy()) mhDefer_.stop();
}

/* ======================================================================
   Global Variables
   ====================================================================== */

EDCA_PHY_MIB::EDCA_PHY_MIB(Mac802_11e *parent)
{
  /*
   * Bind the phy mib objects.  Note that these will be bound
   * to Mac/802_11e variables
   */
  parent->bind("SlotTime_", &SlotTime);
  parent->bind("SIFS_", &SIFSTime);
  parent->bind("PreambleLength_", &PreambleLength);
  parent->bind("PLCPHeaderLength_", &PLCPHeaderLength);
  parent->bind_bw("PLCPDataRate_", &PLCPDataRate);

// printf("PLCPDataRate=%lf", PLCPDataRate);

       parent->bind ("NumRetryOut_",     &parent->num_of_retryout);

       parent->bind ("ThruAP0_",     &ThruAP0);
       parent->bind ("ThruAP1_",     &ThruAP1);
       parent->bind ("ThruAP2_",     &ThruAP2);
       parent->bind ("ThruAP3_",     &ThruAP3);
       parent->bind ("ThruAP4_",     &ThruAP4);
       parent->bind ("ThruAP5_",     &ThruAP5);
       parent->bind ("ThruAP6_",     &ThruAP6);
       parent->bind ("ThruAP7_",     &ThruAP7);
       parent->bind ("ThruAP8_",     &ThruAP8);
       parent->bind ("ThruAP9_",     &ThruAP9);
       parent->bind ("ThruAP10_",     &ThruAP10);
       parent->bind ("ThruAP11_",     &ThruAP11);
       parent->bind ("ThruAP12_",     &ThruAP12);
       parent->bind ("ThruAP13_",     &ThruAP13);
       parent->bind ("ThruAP14_",     &ThruAP14);
       parent->bind ("ThruAP15_",     &ThruAP15);
       parent->bind ("ThruAP16_",     &ThruAP16);
       parent->bind ("ThruAP17_",     &ThruAP17);
       parent->bind ("ThruAP18_",     &ThruAP18);
       parent->bind ("ThruAP19_",     &ThruAP19);

       parent->bind ("NumAP0_",     &NumAP0);
       parent->bind ("NumAP1_",     &NumAP1);
       parent->bind ("NumAP2_",     &NumAP2);
       parent->bind ("NumAP3_",     &NumAP3);
       parent->bind ("NumAP4_",     &NumAP4);
       parent->bind ("NumAP5_",     &NumAP5);
       parent->bind ("NumAP6_",     &NumAP6);
       parent->bind ("NumAP7_",     &NumAP7);
       parent->bind ("NumAP8_",     &NumAP8);
       parent->bind ("NumAP9_",     &NumAP9);
       parent->bind ("NumAP10_",     &NumAP10);
       parent->bind ("NumAP11_",     &NumAP11);
       parent->bind ("NumAP12_",     &NumAP12);
       parent->bind ("NumAP13_",     &NumAP13);
       parent->bind ("NumAP14_",     &NumAP14);
       parent->bind ("NumAP15_",     &NumAP15);
       parent->bind ("NumAP16_",     &NumAP16);
       parent->bind ("NumAP17_",     &NumAP17);
       parent->bind ("NumAP18_",     &NumAP18);
       parent->bind ("NumAP19_",     &NumAP19);
       parent->bind ("NumFromNode0_",     &NumFromNode0);
       parent->bind ("NumFromNode1_",     &NumFromNode1);
       parent->bind ("NumFromNode2_",     &NumFromNode2);
       parent->bind ("NumFromNode3_",     &NumFromNode3);
       parent->bind ("NumFromNode4_",     &NumFromNode4);
       parent->bind ("NumFromNode5_",     &NumFromNode5);
       parent->bind ("NumFromNode6_",     &NumFromNode6);
       parent->bind ("NumFromNode7_",     &NumFromNode7);
       parent->bind ("NumFromNode8_",     &NumFromNode8);
       parent->bind ("NumFromNode9_",     &NumFromNode9);
       parent->bind ("NumFromNode10_",     &NumFromNode10);
       parent->bind ("NumFromNode11_",     &NumFromNode11);
       parent->bind ("NumFromNode12_",     &NumFromNode12);
       parent->bind ("NumFromNode13_",     &NumFromNode13);
       parent->bind ("NumFromNode14_",     &NumFromNode14);
       parent->bind ("NumFromNode15_",     &NumFromNode15);
       parent->bind ("NumFromNode16_",     &NumFromNode16);
       parent->bind ("NumFromNode17_",     &NumFromNode17);
       parent->bind ("NumFromNode18_",     &NumFromNode18);
       parent->bind ("NumFromNode19_",     &NumFromNode19);

       parent->bind ("THRind_",     &parent->THRind);

       parent->bind ("Wq_",     &parent->Wq);
       parent->bind ("Tdrain_",     &parent->Tdrain);

       parent->bind ("Ns_",     &Ns);
       parent->bind ("Nc_",     &Nc);
       parent->bind ("Ni_",     &Ni);
       parent->bind ("Ts_",     &Ts);
       parent->bind ("Ti_",     &Ti);
       parent->bind ("Ri_",     &Ri);
       parent->bind ("Rb_",     &Rb);
       parent->bind ("Rs_",     &Rs);

       parent->bind ("BER_", 		&parent->BER);





}

EDCA_MAC_MIB::EDCA_MAC_MIB(Mac802_11e *parent)
{
  /*
   * Bind the phy mib objects.  Note that these will be bound
   * to Mac/802_11 variables
   */
  
  parent->bind("RTSThreshold_", &RTSThreshold);
  parent->bind("ShortRetryLimit_", &ShortRetryLimit);
  parent->bind("LongRetryLimit_", &LongRetryLimit);
}

/* ======================================================================
   TCL Hooks for the simulator
   ====================================================================== */
static class Mac802_11eClass : public TclClass {
public:
	Mac802_11eClass() : TclClass("Mac/802_11e") {}
	TclObject* create(int, const char*const*) {
		return (new Mac802_11e());
	}
} class_mac802_11e;


/* ======================================================================
   Mac Class Functions
   ====================================================================== */
Mac802_11e::Mac802_11e() : 
  Mac(), phymib_(this), macmib_(this), mhIF_(this), mhNav_(this), mhRecv_(this), mhSend_(this), mhDefer_(this, phymib_.getSlotTime()), mhSifs_(this, phymib_.getSlotTime()), mhBackoff_(this, phymib_.getSlotTime()), AK(this)
{
        // Pointer to PriQ, Cast in priq.cc
	queue_  = 0;
	
	//flags to control if PriQ Parameters have already been adopted
	AIFSset = 0;
	CWset   = 0;
	for(int i=0; i < MAX_PRI; i++){
	    packets_[i] = 0;
	    pktRTS_[i] = 0;
	    pktCTRL_[i] = 0;
	    pktTx_[i] = 0;
	    tx_state_[i] = MAC_IDLE;
	    ssrc_[i] = slrc_[i] = 0;
	    callback_[i] = 0;
	    numbytes_[i] = 0;
	    rtx_[i] = 0;
	    cw_[i] = 0;
	    cwmin_[i] = 0;
	    cwmax_[i] = 0;
	    aifs_[i] = 0;
	    txop_limit_[i] = 0;
	    start_handle_[i] = 0;
	} 
        jitter  =    1000;
	//jitter =   0;
	throughput = 0;
	interval_ =  AK_INTERVAL;
        if(AKAROA) AK.start();
		
	nav_ =       0.0;
	
	rx_state_ =  MAC_IDLE;
	tx_active_ = 0;    
      	
	idle_time =     0;
	sending =       0;
	cfb_dur =       0.0;
	cfb_active =    0;
        cfb_broadcast = 0;
	dl_sentcount=0;
	
	levels =     0;
	slotnum =    0;
	pf =         0;
	cw_old =     0;

	sifs_ = phymib_.getSIFS();
	pifs_ = phymib_.getPIFS();
	difs_ = phymib_.getDIFS();
		
        // see (802.11-1999, 9.2.10) 
	eifs_ = phymib_.getDIFS();
	
	eifs_nav_ =  0;
	
	sta_seqno_ =        1;
	cache_ =            0;
	cache_node_count_ = 0;
	
        // chk if basic/data rates are set
	// otherwise use bandwidth_ as default;
	
	Tcl& tcl = Tcl::instance();
	tcl.evalf("Mac/802_11e set basicRate_");
	if (strcmp(tcl.result(), "0") != 0) 
		bind_bw("basicRate_", &basicRate_);
	else
	    basicRate_ = bandwidth_;

	tcl.evalf("Mac/802_11e set dataRate_");
	if (strcmp(tcl.result(), "0") != 0) 
	  bind_bw("dataRate_", &dataRate_);
	else
	  dataRate_ = bandwidth_;
	
	bind("cfb_", &cfb_);

	THRind = 0.0;
	recvNBind = 0;

}


int
Mac802_11e::command(int argc, const char*const* argv)
{

	if (argc == 3) {
	    if (strcmp(argv[1], "log-target") == 0) {
		logtarget_ = (NsObject*) TclObject::lookup(argv[2]);
		if(logtarget_ == 0)
		    return TCL_ERROR;
		return TCL_OK;
	    } else if(strcmp(argv[1], "nodes") == 0) {
		if(cache_) return TCL_ERROR;
		cache_node_count_ = atoi(argv[2]);
		cache_ = new Host[cache_node_count_ + 1];
		assert(cache_);
		bzero(cache_, sizeof(Host) * (cache_node_count_+1 ));
		return TCL_OK;
	    }
	}
	return Mac::command(argc, argv);
}

/* ======================================================================
   Debugging Routines
   ====================================================================== */

/*
 * dump and packet trace are not adopted to 802.11e yet!
 */

void
Mac802_11e::trace_pkt(Packet *p) {
	struct hdr_cmn *ch = HDR_CMN(p);
	struct hdr_mac802_11e* dh = HDR_MAC802_11E(p);
	u_int16_t *t = (u_int16_t*) &dh->dh_fc;

	fprintf(stderr, "\t[ %2x %2x %2x %2x ] %x %s %d\n",
		*t, dh->dh_duration,
		ETHER_ADDR(dh->dh_da), ETHER_ADDR(dh->dh_sa),
		index_, packet_info.name(ch->ptype()), ch->size());
}

void
Mac802_11e::dump(char *fname)
{
	fprintf(stderr,
		"\n%s --- (INDEX: %d, time: %2.9f)\n",
		fname, index_, Scheduler::instance().clock());

	fprintf(stderr,
		"\ttx_state_: %x, rx_state_: %x, nav: %2.9f, idle: %d\n",
		tx_state_, rx_state_, nav_, is_idle());

	fprintf(stderr,
		"\tpktTx_: %x, pktRx_: %x, pktRTS_: %x, pktCTRL_: %x, callback: %x\n",
		(int) pktTx_, (int) pktRx_, (int) pktRTS_,
		(int) pktCTRL_, (int) callback_);

	fprintf(stderr,
		"\tDefer: %d, Backoff: %d (%d), Recv: %d, Timer: %d Nav: %d\n",
		mhDefer_.busy(), mhBackoff_.busy(), mhBackoff_.paused(),
		mhRecv_.busy(), mhSend_.busy(), mhNav_.busy());
	fprintf(stderr,
		"\tBackoff Expire: %f\n",
		mhBackoff_.expire());
}


/* ======================================================================
   Packet Headers Routines
   ====================================================================== */
inline int
Mac802_11e::hdr_dst(char* hdr, int dst )
{
	struct hdr_mac802_11e *dh = (struct hdr_mac802_11e*) hdr;
	//dst = (u_int32_t)(dst);

	if(dst > -2)
		STORE4BYTE(&dst, (dh->dh_da));

	return ETHER_ADDR(dh->dh_da);
}

inline int 
Mac802_11e::hdr_src(char* hdr, int src )
{
	struct hdr_mac802_11e *dh = (struct hdr_mac802_11e*) hdr;
	if(src > -2)
		STORE4BYTE(&src, (dh->dh_sa));
	return ETHER_ADDR(dh->dh_sa);
}

inline int 
Mac802_11e::hdr_type(char* hdr, u_int16_t type)
{
	struct hdr_mac802_11e *dh = (struct hdr_mac802_11e*) hdr;
	if(type)
		STORE2BYTE(&type,(dh->dh_body));
	return GET2BYTE(dh->dh_body);
}


/* ======================================================================
   Misc Routines
   ====================================================================== */
inline int
Mac802_11e::is_idle()
{
    if(rx_state_ != MAC_IDLE){
      idle_time = 0;
      return 0;
    }
    if(sending) {
      idle_time = 0;
      return 0;
    }
    
    if(nav_ > Scheduler::instance().clock()){
      idle_time = 0;
      return 0;
    }
    idle_time = Scheduler::instance().clock();
    return 1;
}

void
Mac802_11e::discard(Packet *p, const char* why)
{
	hdr_mac802_11e* mh = HDR_MAC802_11E(p);
	hdr_cmn *ch = HDR_CMN(p);


	/* if the rcvd pkt contains errors, a real MAC layer couldn't
	   necessarily read any data from it, so we just toss it now */
	if(ch->error() != 0) {
		Packet::free(p);
		//p = 0;
		return;
	}

	switch(mh->dh_fc.fc_type) {
	case MAC_Type_Management:
		drop(p, why);
		return;
	case MAC_Type_Control:
		switch(mh->dh_fc.fc_subtype) {
		case MAC_Subtype_RTS:
			if((u_int32_t)ETHER_ADDR(mh->dh_sa) == \
			   (u_int32_t)index_) {
				drop(p, why);
				return;
			}
			/* fall through - if necessary */
		case MAC_Subtype_CTS:
		case MAC_Subtype_ACK:
			if((u_int32_t)ETHER_ADDR(mh->dh_da) == \
			   (u_int32_t)index_) {
				drop(p, why);
				return;
			}
			break;
		default:
			fprintf(stderr, "invalid MAC Control subtype\n");
			exit(1);
		}
		break;
	case MAC_Type_Data:
		switch(mh->dh_fc.fc_subtype) {
		case MAC_Subtype_Data:
			if((u_int32_t)ETHER_ADDR(mh->dh_da) == \
			   (u_int32_t)index_ ||
			   (u_int32_t)ETHER_ADDR(mh->dh_sa) == \
			   (u_int32_t)index_ ||
			   (u_int32_t)ETHER_ADDR(mh->dh_da) == MAC_BROADCAST) {
				drop(p, why);
				return;
			}
			break;
		default:
			fprintf(stderr, "invalid MAC Data subtype\n");
			exit(1);
		}
		break;
	default:
		fprintf(stderr, "invalid MAC type (%x)\n", mh->dh_fc.fc_type);
		trace_pkt(p);
		exit(1);
	}
	Packet::free(p);
}

void
Mac802_11e::capture(Packet *p)
{
	/*
	 * Update the NAV so that this does not screw
	 * up carrier sense.
	 */
    	set_nav(usec(eifs_ + txtime(p)));
		      Packet::free(p);
}

void
Mac802_11e::collision(Packet *p)
{
	switch(rx_state_) {
	case MAC_RECV:
		set_rx_state(MAC_COLL);
		/* fall through */
	case MAC_COLL:
		assert(pktRx_);
		assert(mhRecv_.busy());
		/*
		 *  Since a collision has occurred, figure out
		 *  which packet that caused the collision will
		 *  "last" the longest.  Make this packet,
		 *  pktRx_ and reset the Recv Timer if necessary.
		 */
		if(txtime(p) > mhRecv_.expire()) {
			mhRecv_.stop();
			discard(pktRx_, DROP_MAC_COLLISION);
			pktRx_ = p;
			mhRecv_.start(txtime(pktRx_));
		}
		else {
			discard(p, DROP_MAC_COLLISION);
		}
		break;
	default:
		assert(0);
	}
}

void
Mac802_11e::tx_resume()
{
// printf("\nMac802_11e::tx_resume...now=%lf.. %d\n",Scheduler::instance().clock(), index_ );
	double rTime;
	assert(mhSend_.busy() == 0);
	
	for(int pri = 0; pri < MAX_PRI; pri++){
	    //assert(mhDefer_.defer(pri) == 0);
	    if(!mhDefer_.defer(pri)) {
		if(pktCTRL_[pri]) {
// printf("Mac802_11e::tx_resume...now=%lf.. 11111111......%d \n",Scheduler::instance().clock(), index_ );
		/*
		 *  Need to send a CTS or ACK.
		 */
		    mhSifs_.start(pri, sifs_);
		} else if(pktRTS_[pri]) {
// printf("Mac802_11e::tx_resume...now=%lf.. 22222222...... %d \n",Scheduler::instance().clock(), index_ );
		    if(mhBackoff_.backoff(pri) == 0) {
		      rTime = (Random::random() % getCW(LEVEL(pktRTS_[pri]))) * phymib_.getSlotTime();
		      mhDefer_.start(pri, getAIFS(LEVEL(pktRTS_[pri]))); 
		    }
		} else if(pktTx_[pri]) {
// printf("Mac802_11e::tx_resume...now=%lf.. 333333333......%d \n",Scheduler::instance().clock(), index_ );
		    if(mhBackoff_.backoff(pri) == 0) {
			hdr_cmn *ch = HDR_CMN(pktTx_[pri]);
			struct hdr_mac802_11e *mh = HDR_MAC802_11E(pktTx_[pri]);
			
			if ((u_int32_t) ch->size() < macmib_.RTSThreshold ||
			    (u_int32_t) ETHER_ADDR(mh->dh_da) == MAC_BROADCAST) {
			  
			  if((u_int32_t) ETHER_ADDR(mh->dh_da) == MAC_BROADCAST) rTime = (Random::random() % (getCW(pri) + 1)) * phymib_.getSlotTime();
			  else rTime = 0;
			    mhDefer_.start(pri, getAIFS(pri) + rTime);
			} else {
			    mhSifs_.start(pri, sifs_); 
			}
		    }
		} else if(callback_[pri] != 0) {
// printf("Mac802_11e::tx_resume...now=%lf.. callback...... %d \n",Scheduler::instance().clock(), index_ );
		  rtx_[pri] = 0;
		  Handler *h = callback_[pri];
		  callback_[pri] = 0;
		  h->handle((Event*) 0);
		}
		set_tx_state(pri, MAC_IDLE);
	    }
	}
}

void
Mac802_11e::rx_resume()
{
  assert(pktRx_ == 0);
    assert(mhRecv_.busy() == 0);
    set_rx_state(MAC_IDLE);
}


/* ======================================================================
   Timer Handler Routines
   ====================================================================== */
void
Mac802_11e::backoffHandler(int pri)
{
   if(pktCTRL_[pri]) {
    assert(mhSend_.busy() || mhDefer_.defer(pri));
    return;
  }
  
  if(check_pktRTS(pri) == 0)
    return;
  
  if(check_pktTx(pri) == 0)
    return;
}

void
Mac802_11e::deferHandler(int pri)
{
	assert(pktCTRL_[pri] || pktRTS_[pri] || pktTx_[pri]);

	if(check_pktCTRL(pri) == 0)
		return;

	assert(mhBackoff_.backoff(pri) == 0);
	//if (mhBackoff_.busy() != 0)
	//{
	//	printf("deferHandler:mhBackoff_ busy!\n");
	//	return;
	//}
	if(check_pktRTS(pri) == 0)
		return;

	if(check_pktTx(pri) == 0)
		return;
}

void
Mac802_11e::navHandler()
{
    eifs_nav_ = 0.0;
    if(is_idle() && mhBackoff_.paused()) {
		mhBackoff_.resume();
    }
}

void
Mac802_11e::recvHandler()
{
    
	recv_timer();
}

void
Mac802_11e::sendHandler()
{
    Scheduler &s = Scheduler::instance();
    sending = 0;
    check_backoff_timer();
    send_timer();
}


void
Mac802_11e::txHandler()
{
    tx_active_ = 0;
    if(cfb_ && !cfb_broadcast) cfb_active = 0;
    if(cfb_broadcast) cfb_broadcast = 0;
}

void
Mac802_11e::defer_stop(int pri)
{
   mhBackoff_.start(pri, getCW(pri), is_idle());
}

/* sends the throughput every AK_INTERVAL to Akaroa 
 * via AkObservation. This works only if you have 
 * installed Akaroa and the ns-2/Akaroa interface.
 */
void
Mac802_11e::calc_throughput()
{
#if AKAROA > 0
  if(AKAROA){	
    if(index_ > 0){
      //int pri = 2; 
      // jitter is for cases in which the simulation is
      // already in a steady state at the very beginning
      if (jitter >0) {if(jitter >= 10 ) jitter -= 10; }
      for(int pri = 0; pri < 3; pri++){
	if(jitter > 0){
	  throughput = ((numbytes_[pri] * 8.) / interval_) + Random::uniform(0,jitter);
	}else {
	  throughput = (8. * numbytes_[pri]) / interval_;
	}
	if(throughput <= 0) throughput = 0.0001;
	AkObservation((3 * (index_ - 1)) + (pri + 1), throughput);
	//AkObservation((6 * (index_ - 1)) + (pri + 1), throughput);
	//AkObservation((pri + 1), throughput);
	//AkObservation(1, throughput);
	//if(index_ == 1 && pri == 0) {
	cout.precision(16);
	//cout<<"Mac "<<index_<<", now: "<<Scheduler::instance().clock()<<", priority "<<pri<<", throughput: "<<throughput<<", interval_: "<<interval_<<" numbytes " << numbytes_[pri] <<"  jitter "<<jitter<<"\n";
	//}
	numbytes_[pri] = 0; throughput = 0;
      }
      AK.start();
    } 
  }
#endif
}

/* ======================================================================
   The "real" Timer Handler Routines
   ====================================================================== */
void
Mac802_11e::send_timer()
{   
 Scheduler &s = Scheduler::instance();
    for(int pri = 0; pri < MAX_PRI; pri ++){
	switch(tx_state_[pri]) {
	/*
	 * Sent a RTS, but did not receive a CTS.
	 */
	case MAC_RTS:
		RetransmitRTS(pri);
		break;
	/*
	 * Sent a CTS, but did not receive a DATA packet.
	 */
	case MAC_CTS:
		assert(pktCTRL_[pri]);
		Packet::free(pktCTRL_[pri]); pktCTRL_[pri] = 0;
		break;
	/*
	 * Sent DATA, but did not receive an ACK packet.
	 */
	case MAC_SEND:
		RetransmitDATA(pri);
		break;
	/*
	 * Sent an ACK, and now ready to resume transmission.
	 */
	case MAC_ACK:
		assert(pktCTRL_[pri]);
		Packet::free(pktCTRL_[pri]); pktCTRL_[pri] = 0;
		break;
	case MAC_IDLE:
		break;
	default:
		assert(0);
	}
    }
    //  if(mhDefer_.busy()) mhDefer_.stop();
    if(!cfb_active) tx_resume();
    
}

/* ======================================================================
   Outgoing Packet Routines
   ====================================================================== */
int
Mac802_11e::check_pktCTRL(int pri) 
{

	struct hdr_mac802_11e *mh;
	double timeout;

	if(pktCTRL_[pri] == 0)
		return -1;
	if(tx_state_[pri] == MAC_CTS || tx_state_[pri] == MAC_ACK)
		return -1;

	mh = HDR_MAC802_11E(pktCTRL_[pri]);
							  
	switch(mh->dh_fc.fc_subtype) {
	/*
	 *  If the medium is not IDLE, don't send the CTS.
	 */
	    case MAC_Subtype_CTS:
	      if(!is_idle()) {
			discard(pktCTRL_[pri], DROP_MAC_BUSY); pktCTRL_[pri] = 0;
			return 0;
	      }
		set_tx_state(pri, MAC_CTS);
		
		/*
		 * timeout:  cts + data tx time calculated by
		 *           adding cts tx time to the cts duration
		 *           minus ack tx time -- this timeout is
		 *           a guess since it is unspecified
		 *           (note: mh->dh_duration == cf->cf_duration)
		 */
		timeout = txtime(phymib_.getCTSlen(), basicRate_)
			+ DSSS_EDCA_MaxPropagationDelay			// XXX
			+ sec(mh->dh_duration)
			+ DSSS_EDCA_MaxPropagationDelay			// XXX
			- sifs_
			- txtime(phymib_.getACKlen(), basicRate_);
		
		break;
		/*
		 * IEEE 802.11 specs, section 9.2.8
		 * Acknowledments are sent after an SIFS, without regard to
		 * the busy/idle state of the medium.
		 */
	    case MAC_Subtype_ACK:
		set_tx_state(pri, MAC_ACK);

		timeout = txtime(phymib_.getACKlen(), basicRate_);
		
		break;
	default:
		fprintf(stderr, "check_pktCTRL:Invalid MAC Control subtype\n");
		exit(1);
	}
	transmit(pktCTRL_[pri], timeout);
	return 0;
}

int
Mac802_11e::check_pktRTS(int pri) 
{

	struct hdr_mac802_11e *mh;
	double timeout;

	assert(mhBackoff_.backoff(pri) == 0);
	if(pktRTS_[pri] == 0)
 		return -1;
	//struct hdr_cmn *ch = HDR_CMN(pktRTS_);
	mh = HDR_MAC802_11E(pktRTS_[pri]);

 	switch(mh->dh_fc.fc_subtype) {
	case MAC_Subtype_RTS:
	  if(! is_idle()) {
		    inc_cw(pri); 
		    mhBackoff_.start(pri, getCW(pri), is_idle());

		    return 0;
	  }
		set_tx_state(pri, MAC_RTS);
		timeout = txtime(phymib_.getRTSlen(), basicRate_)
			+ DSSS_EDCA_MaxPropagationDelay			// XXX
			+ sifs_
			+ txtime(phymib_.getCTSlen(), basicRate_)
			+ DSSS_EDCA_MaxPropagationDelay;			// XXX
		break;
	default:
	    fprintf(stderr, "check_pktRTS:Invalid MAC Control subtype\n");
		exit(1);
	}
	transmit(pktRTS_[pri], timeout);
	return 0;
}

int 
Mac802_11e::check_pktTx(int pri)
{

        struct hdr_mac802_11e *mh;
	double timeout;
	assert(mhBackoff_.backoff(pri) == 0);
	
	if(pktTx_[pri] == 0) {
	    return -1;
	}
	
	mh = HDR_MAC802_11E(pktTx_[pri]);
       	//int len = HDR_CMN(pktTx_)->size();
	switch(mh->dh_fc.fc_subtype) {
	case MAC_Subtype_Data:
	    
	    /*if(!is_idle()){
	      sendRTS(pri, ETHER_ADDR(mh->dh_da));
	      inc_cw(LEVEL(pktTx_[pri]));
	      mhBackoff_.start(LEVEL(pktTx_[pri]), getCW(LEVEL(pktTx_[pri])), is_idle());
	      return 0;
	    }*/
	    
	    set_tx_state(pri, MAC_SEND);
	    if((u_int32_t)ETHER_ADDR(mh->dh_da) != MAC_BROADCAST)
		timeout = txtime(pktTx_[pri])
		            + DSSS_EDCA_MaxPropagationDelay		// XXX
			    + sifs_
			    + txtime(phymib_.getACKlen(), basicRate_)
			    + DSSS_EDCA_MaxPropagationDelay;		// XXX
		else
		    timeout = txtime(pktTx_[pri]);
		break;
	    default:
	    fprintf(stderr, "check_pktTx:Invalid MAC Control subtype\n");
		//printf("pktRTS:%x, pktCTS/ACK:%x, pktTx:%x\n",pktRTS_, pktCTRL_,pktTx_);
		exit(1);
	}
	transmit(pktTx_[pri], timeout);
	return 0;
}
/*
 * Low-level transmit functions that actually place the packet onto
 * the channel.
 */
void
Mac802_11e::sendRTS(int pri, int dst)
{

	Packet *p = Packet::alloc();
	hdr_cmn* ch = HDR_CMN(p);
	struct rts_frame *rf = (struct rts_frame*)p->access(hdr_mac::offset_);
	
	assert(pktTx_[pri]);
	assert(pktRTS_[pri] == 0);

	/*
	 *  If the size of the packet is larger than the
	 *  RTSThreshold, then perform the RTS/CTS exchange.
	 *
	 *  XXX: also skip if destination is a broadcast
	 */
	if( (u_int32_t) HDR_CMN(pktTx_[pri])->size() < macmib_.RTSThreshold ||
	    (u_int32_t) dst == MAC_BROADCAST) {
		Packet::free(p);
		//p = 0;
		return;
	}

	ch->uid() = 0;
	ch->ptype() = PT_MAC;
	ch->size() = phymib_.getRTSlen();
	ch->iface() = -2;
	ch->error() = 0;

	bzero(rf, MAC_HDR_LEN);

	rf->rf_fc.fc_protocol_version = MAC_ProtocolVersion;
 	rf->rf_fc.fc_type	= MAC_Type_Control;
 	rf->rf_fc.fc_subtype	= MAC_Subtype_RTS;
 	rf->rf_fc.fc_to_ds	= 0;
 	rf->rf_fc.fc_from_ds	= 0;
 	rf->rf_fc.fc_more_frag	= 0;
 	rf->rf_fc.fc_retry	= 0;
 	rf->rf_fc.fc_pwr_mgt	= 0;
 	rf->rf_fc.fc_more_data	= 0;
 	rf->rf_fc.fc_wep	= 0;
 	rf->rf_fc.fc_order	= 0;

	//rf->rf_duration = RTS_DURATION(pktTx_);
	STORE4BYTE(&dst, (rf->rf_ra));
	
	/* store rts tx time */
 	ch->txtime() = txtime(ch->size(), basicRate_);
	
	STORE4BYTE(&index_, (rf->rf_ta));
	/* calculate rts duration field */
	rf->rf_duration = usec(sifs_
			       + txtime(phymib_.getCTSlen(), basicRate_)
			       + sifs_
			       + txtime(pktTx_[pri])
			       + sifs_
			       + txtime(phymib_.getACKlen(), basicRate_));
	
	
	pktRTS_[pri] = p;
}

void
Mac802_11e::sendCTS(int pri, int dst, double rts_duration)
{

	Packet *p = Packet::alloc();
	hdr_cmn* ch = HDR_CMN(p);
	struct cts_frame *cf = (struct cts_frame*)p->access(hdr_mac::offset_);

	assert(pktCTRL_[pri] == 0);

	ch->uid() = 0;
	ch->ptype() = PT_MAC;
	ch->size() = phymib_.getCTSlen();
	ch->iface() = -2;
	ch->error() = 0;
	//ch->direction() = hdr_cmn::DOWN;
	bzero(cf, MAC_HDR_LEN);

	cf->cf_fc.fc_protocol_version = MAC_ProtocolVersion;
	cf->cf_fc.fc_type	= MAC_Type_Control;
	cf->cf_fc.fc_subtype	= MAC_Subtype_CTS;
 	cf->cf_fc.fc_to_ds	= 0;
 	cf->cf_fc.fc_from_ds	= 0;
 	cf->cf_fc.fc_more_frag	= 0;
 	cf->cf_fc.fc_retry	= 0;
 	cf->cf_fc.fc_pwr_mgt	= 0;
 	cf->cf_fc.fc_more_data	= 0;
 	cf->cf_fc.fc_wep	= 0;
 	cf->cf_fc.fc_order	= 0;
	
	//cf->cf_duration = CTS_DURATION(rts_duration);
	STORE4BYTE(&dst, (cf->cf_ra));
	
	/* store cts tx time */
	ch->txtime() = txtime(ch->size(), basicRate_);
	
	/* calculate cts duration */
	cf->cf_duration = usec(sec(rts_duration)
			       - sifs_
			       - txtime(phymib_.getCTSlen(), basicRate_));
	
	pktCTRL_[pri] = p;
	
}

void
Mac802_11e::sendACK(int pri, int dst, double ts, int data_index )
{

	Packet *p = Packet::alloc();
	hdr_cmn* ch = HDR_CMN(p);
	struct ack_frame *af = (struct ack_frame*)p->access(hdr_mac::offset_);
	assert(pktCTRL_[pri] == 0);

// 	ch->uid() = 0; // ACK-UID
	ch->uid() = data_index; // ACK-UID
	ch->ptype() = PT_MAC;
	ch->size() = phymib_.getACKlen();
	ch->iface() = -2;
	ch->error() = 0;

	ch->timestamp() = ts;

	HDR_IP(p)->prio() = pri; //same priority as data packet
	bzero(af, MAC_HDR_LEN);

	af->af_fc.fc_protocol_version = MAC_ProtocolVersion;
 	af->af_fc.fc_type	= MAC_Type_Control;
 	af->af_fc.fc_subtype	= MAC_Subtype_ACK;
 	af->af_fc.fc_to_ds	= 0;
 	af->af_fc.fc_from_ds	= 0;
 	af->af_fc.fc_more_frag	= 0;
 	af->af_fc.fc_retry	= 0;
 	af->af_fc.fc_pwr_mgt	= 0;
 	af->af_fc.fc_more_data	= 0;
 	af->af_fc.fc_wep	= 0;
 	af->af_fc.fc_order	= 0;

	//af->af_duration = ACK_DURATION();
	STORE4BYTE(&dst, (af->af_ra));

	/* store ack tx time */
 	ch->txtime() = txtime(ch->size(), basicRate_);
	
	/* calculate ack duration */
 	af->af_duration = 0;	
	
	pktCTRL_[pri] = p;
}

void
Mac802_11e::sendDATA(int pri, Packet *p)
{

	hdr_cmn* ch = HDR_CMN(p);
	struct hdr_mac802_11e* dh = HDR_MAC802_11E(p);
	assert(pktTx_[pri] == 0);

//  Tianji Li, record start time at MAC when TXOP is enabled
        int src = ETHER_ADDR(dh->dh_sa);
	////int pri = LEVEL(p);

	if ( src == 16 && ch->ptype() == PT_TCP && ch->size() != 40 && pri == 1  ) {
	  ch->timestamp() = Scheduler::instance().clock(); 
	}
//  Tianji Li, record start time at MAC when TXOP is enabled


// printf("Mac802_11e::sendDATA...now=%lf, pkt %d, ts=%lf... %d\n",  Scheduler::instance().clock(), ch->uid(), ch->timestamp(), index_); 
	/*
	 * Update the MAC header
	 */
	ch->size() += phymib_.getHdrLen11();

	dh->dh_fc.fc_protocol_version = MAC_ProtocolVersion;
	dh->dh_fc.fc_type       = MAC_Type_Data;
	dh->dh_fc.fc_subtype    = MAC_Subtype_Data;
	//printf(".....p = %x, mac-subtype-%d\n",p,dh->dh_fc.fc_subtype);
	
	dh->dh_fc.fc_to_ds      = 0;
	dh->dh_fc.fc_from_ds    = 0;
	dh->dh_fc.fc_more_frag  = 0;
	dh->dh_fc.fc_retry      = 0;
	dh->dh_fc.fc_pwr_mgt    = 0;
	dh->dh_fc.fc_more_data  = 0;
	dh->dh_fc.fc_wep        = 0;
	dh->dh_fc.fc_order      = 0;

	/* store data tx time */
	if((u_int32_t)ETHER_ADDR(dh->dh_da) != MAC_BROADCAST) {
		/* store data tx time for unicast packets */
		ch->txtime() = txtime(ch->size(), dataRate_);
		
		//dh->dh_duration = DATA_DURATION();
		
		dh->dh_duration = usec(txtime(phymib_.getACKlen(), basicRate_) 
 				       + sifs_);
	} else {
		/* store data tx time for broadcast packets (see 9.6) */
		ch->txtime() = txtime(ch->size(), basicRate_);
		
		dh->dh_duration = 0;
	}

	pktTx_[pri] = p;
}

/* ======================================================================
   Retransmission Routines
   ====================================================================== */
void
Mac802_11e::RetransmitRTS(int pri)
{

	assert(pktTx_[pri]);
	assert(pktRTS_[pri]);
	assert(mhBackoff_.backoff(pri) == 0);

	macmib_.RTSFailureCount++;

	ssrc_[pri] += 1;			// STA Short Retry Count

	if(ssrc_[pri] >= macmib_.ShortRetryLimit) {
		discard(pktRTS_[pri], DROP_MAC_RETRY_COUNT_EXCEEDED); pktRTS_[pri] = 0;
		/* tell the callback the send operation failed 
		   before discarding the packet */
		hdr_cmn *ch = HDR_CMN(pktTx_[pri]);
		if (ch->xmit_failure_) {
                        /*
                         *  Need to remove the MAC header so that 
                         *  re-cycled packets don't keep getting
                         *  bigger.
                         */
                        ch->size() -= phymib_.getHdrLen11();
                        ch->xmit_reason_ = XMIT_REASON_RTS;
                        ch->xmit_failure_(pktTx_[pri]->copy(),
                                          ch->xmit_failure_data_);
                }
		//printf("(%d)....discarding RTS:%x\n",index_,pktRTS_);
		rst_cw(pri);		
		discard(pktTx_[pri], DROP_MAC_RETRY_COUNT_EXCEEDED); pktTx_[pri] = 0;
		ssrc_[pri] = 0;
		
	} else {
		//printf("(%d)...retxing RTS:%x\n",index_,pktRTS_);
		struct rts_frame *rf;
		rf = (struct rts_frame*)pktRTS_[pri]->access(hdr_mac::offset_);
		rf->rf_fc.fc_retry = 1;

		inc_cw(LEVEL(pktTx_[pri]));
		mhBackoff_.start(LEVEL(pktTx_[pri]), getCW(pri), is_idle());
	}
}

void
Mac802_11e::RetransmitDATA(int pri)
{
    
	struct hdr_cmn *ch;
	struct hdr_mac802_11e *mh;
	u_int32_t *rcount, *thresh;

	assert(mhBackoff_.backoff(pri) == 0);
	
	assert(pktTx_[pri]);
	assert(pktRTS_[pri] == 0);

	ch = HDR_CMN(pktTx_[pri]);
	mh = HDR_MAC802_11E(pktTx_[pri]);

	struct hdr_mac802_11e *dh = HDR_MAC802_11E(pktTx_[pri]);
	u_int32_t dst, src;
	src = ETHER_ADDR(dh->dh_sa);
	
	/*
	 *  Broadcast packets don't get ACKed and therefore
	 *  are never retransmitted.
	 */
	if((u_int32_t)ETHER_ADDR(mh->dh_da) == MAC_BROADCAST) {
	  /*
	   * Backoff at end of TX.
	   */
	  if(!cfb_ || rx_state_ != MAC_IDLE){
		rst_cw(pri);
		mhBackoff_.start(pri, getCW(pri), is_idle());
		Packet::free(pktTx_[pri]); pktTx_[pri] = 0;
		return;
	  } else{
	    // if this is the first packet in cfb, we must take its
	    // duration into account, too.
	    if(cfb_dur < 1e-6) {
// 	    if(cfb_dur == 0) {
	      //cout<<"Mac "<<index<<", setting cfb_dur after Broadcast\n";
	      cfb_dur = txtime(pktTx_[pri]) + sifs_;
		            //+ txtime(phymib_.getACKlen(), basicRate_);
		  if (txop_limit_[pri] >= 1.0) {
			cfb_dur =1.0;  dl_sentcount=0;
		  }
	    }
	    assert(pktTx_[pri]);
	    Packet::free(pktTx_[pri]); pktTx_[pri] = 0;
	    cfb(pri);
	    return;
	    }
	} else if(cfb_) cfb_dur = 0.0;

	macmib_.ACKFailureCount++;
	rtx_[pri] = 1;
	if((u_int32_t) ch->size() <= macmib_.RTSThreshold) {
		rcount = &ssrc_[pri];
		thresh = &macmib_.ShortRetryLimit;
	}
	else {
		rcount = &slrc_[pri];
		thresh = &macmib_.LongRetryLimit;
	}

	(*rcount)++;
	if ( src==16 && pri==1 )     ltj_retry_count = *rcount;	

	if(*rcount > *thresh) {
	  numbytes_[pri] -= ch->size() - phymib_.getHdrLen11();
	  rtx_[pri] = 0;
	  macmib_.FailedCount++;
	  /* tell the callback the send operation failed 
	     before discarding the packet */
	  hdr_cmn *ch = HDR_CMN(pktTx_[pri]);
	  if (ch->xmit_failure_) {
	    ch->size() -= phymib_.getHdrLen11();
	    ch->xmit_reason_ = XMIT_REASON_ACK;
	    ch->xmit_failure_(pktTx_[pri]->copy(),
			      ch->xmit_failure_data_);
                }
	  rst_cw(pri);

// printf("DATA discarded: count exceeded.....  size=%d. %d\n", ch->size(), index_);
	num_of_retryout ++;

	  discard(pktTx_[pri], DROP_MAC_RETRY_COUNT_EXCEEDED); pktTx_[pri] = 0;
	  *rcount = 0;
	  if ( src==16 && pri==1 ) ltj_retry_count = *rcount;	
		
	}
	else {
		struct hdr_mac802_11e *dh;
		dh = HDR_MAC802_11E(pktTx_[pri]);
		dh->dh_fc.fc_retry = 1;

		sendRTS(pri, ETHER_ADDR(mh->dh_da));
		//printf("(%d)retxing data:%x..sendRTS..\n",index_,pktTx_);
		inc_cw(LEVEL(pktTx_[pri]));
		mhBackoff_.start(pri, getCW(pri), is_idle());
	}
}

/* ======================================================================
   Incoming Packet Routines
   ====================================================================== */
void
Mac802_11e::send(Packet *p, Handler *h)

{

        int pri = LEVEL(p);
	start_handle_[pri]=Scheduler::instance().clock();
	double rTime;
	struct hdr_mac802_11e* dh = HDR_MAC802_11E(p);

	/* 
	 * drop the packet if the node is in sleep mode
	 XXX sleep mode can't stop node from sending packets
	 */
	EnergyModel *em = netif_->node()->energy_model();
	if (em && em->sleep()) {
		em->set_node_sleep(0);
		em->set_node_state(EnergyModel::INROUTE);
	}
	callback_[pri] = h;
	sendDATA(pri, p); // framing and calculation of  tx Duration 
	sendRTS(pri, ETHER_ADDR(dh->dh_da)); //check whether size exceeds RTSthreshold 

	/*
	 * Assign the data packet a sequence number.
	 */
	dh->dh_scontrol = sta_seqno_++;

	/*
	 *  If the medium is IDLE, we must wait for a DIFS
	 *  Space before transmitting.
	 */
        assert(mhDefer_.defer(pri) == 0); 
	
	if(mhBackoff_.backoff(pri) == 0) { //Mac can be still  in post-backoff
	  if(is_idle()) { 
			/*
			 * If we are already deferring, there is no
			 * need to reset the Defer timer.
			 */
			if(mhDefer_.defer(pri) == 0) {
			  rTime = ((Random::random() % getCW(LEVEL(p))) * phymib_.getSlotTime());
			    mhDefer_.start(LEVEL(p), getAIFS(LEVEL(p))); // + rTime);// - phymib_.getSlotTime());
				

			}			
		}
	/*
	 * If the medium is NOT IDLE, then we start
	 * the backoff timer.
	 */
		else {
		    mhBackoff_.start(LEVEL(p),getCW(LEVEL(p)), is_idle());
		}
	}  
	    
}

void
Mac802_11e::recv(Packet *p, Handler *h)
{
   	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac802_11e *dh = HDR_MAC802_11E(p);
        int dst = ETHER_ADDR(dh->dh_da);
        int src = ETHER_ADDR(dh->dh_sa);
	int pri = LEVEL(p);


	if( hdr->direction() == hdr_cmn::DOWN) {
	    if ( src == 16 && pri == 1  ) {
// printf("mac, start sending\n");
		hdr->timestamp() = Scheduler::instance().clock(); 

		if( queue_->pri_[pri].getLen() <= 0)  {
			t_e = Scheduler::instance().clock();
// printf("mac, setting t_e in recvBBBBB.....\n");
		}
	    }



	    Scheduler &s = Scheduler::instance();
	    send(p, h);
	    return;
        }
	/*
	 *  Handle incoming packets.
	 *
	 *  We just received the 1st bit of a packet on the network
	 *  interface.
	 *
	 */
	/*
	 *  If the interface is currently in transmit mode, then
	 *  it probably won't even see this packet.  However, the
	 *  "air" around me is BUSY so I need to let the packet
	 *  proceed.  Just set the error flag in the common header
	 *  to that the packet gets thrown away.
	 */
/*#ifdef Tianji_Li_DEBUG_0
printf("Mac802_11e::recv..sending up,,,,,,size=%d, id=%d, src=%d, dst=%d...%d\n", 
hdr->size(), hdr->uid(), src, dst, index_);
#endif*/
	Scheduler &s = Scheduler::instance();
	if(tx_active_ && hdr->error() == 0 ) {
        		hdr->error() = 1;
	
	}

	if(rx_state_ == MAC_IDLE) {
		set_rx_state(MAC_RECV);
		pktRx_ = p;

		/*
		 * Schedule the reception of this packet, in
		 * txtime seconds.
		 */
		mhRecv_.start(txtime(p));
	} else {
		/*
		 *  If the power of the incoming packet is smaller than the
		 *  power of the packet currently being received by at least
                 *  the capture threshold, then we ignore the new packet.
		 */
		if(pktRx_->txinfo_.RxPr / p->txinfo_.RxPr >= p->txinfo_.CPThresh) {
			capture(p);
		} else {
			collision(p);
		}
	}
}


// return: Ts, Ti, Ni, Nc, TT
void
Mac802_11e::num_idle_slot()
{
	hdr_cmn *ch = HDR_CMN(pktRx_);
			double tmpT = txtime(pktRx_)
				+ DSSS_MaxPropagationDelay
				+ phymib_.getSIFS()
				+ txtime(phymib_.getACKlen(), basicRate_)
				+ DSSS_MaxPropagationDelay; 


			Ts = tmpT;
// 			TTs = TTs + Ts;
			Ti = phymib_.getSlotTime();
// printf("Mac802_11e::num_idle_slot, now=%lf, Ns=%d, Nc=%d, Ni=%d.. %d\n", Scheduler::instance().clock(), Ns, Nc, Ni, index_);

			double tmp_idle_duration = Scheduler::instance().clock() - tmpT - TT;
			double tmp_num_slot = tmp_idle_duration / phymib_.getSlotTime();
			if ( tmp_idle_duration>0 ) Ni = Ni + (int)round(tmp_num_slot );
			else Nc --;

// printf("Mac802_11e::num_idle_slot, now=%lf, pid=%d, tmp_num_slot=%d.. %d\n", Scheduler::instance().clock(), ch->uid(), (int)round(tmp_num_slot ), index_);

			TT = Scheduler::instance().clock();
// if ( tmp_idle_duration <= 0 )  printf("tmp_idle_duration=%lf, Ts=%lf, Ni=%d, Ns=%d, Nc=%d, pkt size=%d.. \n", tmp_idle_duration, Ts, Ni, Ns, Nc, ch->size());
}



void
Mac802_11e::recv_timer()
{ 

    Scheduler &s = Scheduler::instance();
	u_int32_t src; 
	hdr_cmn *ch = HDR_CMN(pktRx_);
	hdr_mac802_11e *mh = HDR_MAC802_11E(pktRx_);
	u_int32_t dst = ETHER_ADDR(mh->dh_da);
        Tcl         & ttcl = Tcl::instance();
	// XXX debug
	//struct cts_frame *cf = (struct cts_frame*)pktRx_->access(hdr_mac::offset_);
	//u_int32_t src = ETHER_ADDR(mh->dh_sa);
	
	u_int8_t  type = mh->dh_fc.fc_type;
	u_int8_t  subtype = mh->dh_fc.fc_subtype;

	assert(pktRx_);
	assert(rx_state_ == MAC_RECV || rx_state_ == MAC_COLL);
	
 	double 	per = 0.0;
 	double 	var;

 	var = phymib_.rand_.uniform();
         per = 1 - pow ( 1-BER, ch->size()*8 );
 	if( ch->ptype() == PT_CBR || ch->ptype() == PT_TCP || ch->ptype() == PT_UDP || ch->ptype() == PT_EXP  ) 
 	{
 		if (var <= per) 
 		{
 			ch->error() = 1; // corrupted
 		} else
 		{
 			ch->error() = 0; 
 		}
 	}

        /*
         *  If the interface is in TRANSMIT mode when this packet
         *  "arrives", then I would never have seen it and should
         *  do a silent discard without adjusting the NAV.
         */
        if(tx_active_) {
                Packet::free(pktRx_);
                goto done;
        }

	/*
	 * Handle collisions.
	 */
	if(rx_state_ == MAC_COLL) {
// The receiver counts the number of collisions
// 		if ( index_ == 3 || index_ == 4 || index_ >= 30 ) 
		if ( index_ == 16 || (index_ <= 29 || index_ >= 20) ) 
		{
			if( ch->ptype() == PT_CBR || ch->ptype() == PT_TCP || ch->ptype() == PT_UDP || ch->ptype() == PT_EXP|| ch->ptype() == PT_ACK  ) {
				if( dst == (u_int32_t)index_  ) {
					Nc ++;
// printf("num_idle_slot, 1111, now=%lf, pid=%d, %d\n", Scheduler::instance().clock(), ch->uid(), index_);
					num_idle_slot();
					TTc = TTc + Ts;
				}
			}
		}
// The receiver counts the number of collisions
	    discard(pktRx_, DROP_MAC_COLLISION);
	    set_nav(usec(eifs_));
	    eifs_nav_ = eifs_;
	    goto done;
	}
	
	/*
	 * Check to see if this packet was received with enough
	 * bit errors that the current level of FEC still could not
	 * fix all of the problems - ie; after FEC, the checksum still
	 * failed.
	 */
	if( ch->error() ) {
// The receiver counts the number of collisions
// 		if ( index_ == 3 || index_ == 4 || index_ >= 30 ) 
		if ( index_ == 16 || (index_ <= 29 || index_ >= 20) ) 
		{
			if( ch->ptype() == PT_CBR || ch->ptype() == PT_TCP || ch->ptype() == PT_UDP || ch->ptype() == PT_EXP|| ch->ptype() == PT_ACK  ) {
				if(dst == (u_int32_t)index_) {
					Nc ++;
// printf("num_idle_slot, 2222, now=%lf, pid=%d, %d\n", Scheduler::instance().clock(), ch->uid(), index_);
					num_idle_slot();
					TTc = TTc + Ts;
				}
			}
		}
// The receiver counts the number of collisions
	    Packet::free(pktRx_);
	    set_nav(usec(eifs_));
	    eifs_nav_ = eifs_;
	    goto done;
	}
	
// printf("Mac802_11e::recv_timer..111111111111...%d\n", index_);

	/*
	 * avoid Nav-reset bug:
	 * if received packet has no  errors and had no collision, but nav 
	 * was set due to an earlier collision, nav has to be reset!
	 */
         if(mhNav_.busy()) reset_eifs_nav();
	
	/*
	 * IEEE 802.11 specs, section 9.2.5.6
	 *	- update the NAV (Network Allocation Vector)
	 */
	if(dst != (u_int32_t)index_) {
	    set_nav(mh->dh_duration);
	}

        /* tap out - */
        if (tap_ && type == MAC_Type_Data &&
            MAC_Subtype_Data == subtype ) 
		tap_->tap(pktRx_);
	/*
	 * Adaptive Fidelity Algorithm Support - neighborhood infomation 
	 * collection
	 *
	 * Hacking: Before filter the packet, log the neighbor node
	 * I can hear the packet, the src is my neighbor
	 */
	if (netif_->node()->energy_model() && 
	    netif_->node()->energy_model()->adaptivefidelity()) {
		src = ETHER_ADDR(mh->dh_sa);
		netif_->node()->energy_model()->add_neighbor(src);
	}
	/*
	 * Address Filtering
	 */
	if(dst != (u_int32_t)index_ && dst != MAC_BROADCAST) {
		/*
		 *  We don't want to log this event, so we just free
		 *  the packet instead of calling the drop routine.
		 */
		discard(pktRx_, "---");
		goto done;
	}
// printf("Mac802_11e::recv_timer..22222222222222222...%d\n", index_);

// The receiver counts the number of successful transmissions
// 	if ( index_ == 3 || index_ == 4 || index_ >= 30 ) 
	if ( index_ == 16 || (index_ <= 29 || index_ >= 20) ) 
	{
		if( ch->ptype() == PT_CBR || ch->ptype() == PT_TCP || ch->ptype() == PT_UDP || ch->ptype() == PT_EXP|| ch->ptype() == PT_ACK  ) {
			if(dst == (u_int32_t)index_) {
				Ns ++;
// printf("num_idle_slot, 3333, now=%lf, pid=%d, %d\n", Scheduler::instance().clock(), ch->uid(), index_);
				num_idle_slot();
				TTs = TTs + Ts;
			}
		}
	}

// // The receiver counts the number of successful transmissions
        ttcl.evalf("Mac/802_11e set Ns_ %d", Ns);
        ttcl.evalf("Mac/802_11e set Nc_ %d", Nc);
        ttcl.evalf("Mac/802_11e set Ni_ %d", Ni);
        ttcl.evalf("Mac/802_11e set Ts_ %lf", Ts);
        ttcl.evalf("Mac/802_11e set Ti_ %lf", Ti);

	Ri = (double)(Ni*Ti)/(Ni*Ti+TTs+TTc);
	Rb = 1.0 - Ri;
	if ( Ni*Ti+TTs+TTc != 0 ) Rs = (double)TTs/(Ni*Ti+TTs+TTc);

// printf("Mac802_11e::recv_timer..now=%lf,  Rb=%lf,  ...%d\n", Scheduler::instance().clock(), Rb, index_);


        ttcl.evalf("Mac/802_11e set Ri_ %lf", Ri);
        ttcl.evalf("Mac/802_11e set Rb_ %lf", Rb);
        ttcl.evalf("Mac/802_11e set Rs_ %lf", Rs);


// printf("Mac802_11e::recv_timer..3333333333333333...%d\n", index_);

	switch(type) {

	case MAC_Type_Management:
		discard(pktRx_, DROP_MAC_PACKET_ERROR);
		goto done;
		break;

	case MAC_Type_Control:
		switch(subtype) {
		case MAC_Subtype_RTS:
			recvRTS(pktRx_);
			break;
		case MAC_Subtype_CTS:
			recvCTS(pktRx_);
			break;
		case MAC_Subtype_ACK:
			recvACK(pktRx_);
			break;
		default:
			fprintf(stderr,"recvTimer1:Invalid MAC Control Subtype %x\n",
				subtype);
			exit(1);
		}
		break;
	case MAC_Type_Data:
		switch(subtype) {
		case MAC_Subtype_Data:
			recvDATA(pktRx_);
			break;
		default:
			fprintf(stderr, "recv_timer2:Invalid MAC Data Subtype %x\n",
				subtype);
			exit(1);
		}
		break;
	default:
		fprintf(stderr, "recv_timer3:Invalid MAC Type %x\n", subtype);
		exit(1);
	}
 done:
	pktRx_ = 0;
	rx_resume();
}


void
Mac802_11e::recvRTS(Packet *p)
{

        int pri = LEVEL(p);
	struct rts_frame *rf = (struct rts_frame*)p->access(hdr_mac::offset_);

	if(tx_state_[pri] != MAC_IDLE) {
		discard(p, DROP_MAC_BUSY);
		return;
	}

	/*
	 *  If I'm responding to someone else, discard this RTS.
	 */
	if(pktCTRL_[pri]) {
		discard(p, DROP_MAC_BUSY);
		return;
	}

	sendCTS(pri, ETHER_ADDR(rf->rf_ta), rf->rf_duration);

	tx_resume();

	mac_log(p);
}

/*
 * txtime()	- pluck the precomputed tx time from the packet header
 */
double
Mac802_11e::txtime(Packet *p)
 {
	 struct hdr_cmn *ch = HDR_CMN(p);
	 double t = ch->txtime();
	 if (t < 0.0) {
		 drop(p, "XXX");
 		exit(1);
	 }
	 return t;
 }

 
/*
 * txtime()	- calculate tx time for packet of size "psz" bytes 
 *		  at rate "drt" bps
 */
double
Mac802_11e::txtime(double psz, double drt)
{
  double dsz = psz - phymib_.getPLCPhdrLen();
  int plcp_hdr = phymib_.getPLCPhdrLen() << 3;
  int datalen = (int)dsz << 3;
  
  double t = (((double)plcp_hdr)/phymib_.getPLCPDataRate()) + (((double)datalen)/drt);
  return(t);
}



void
Mac802_11e::recvCTS(Packet *p)
{

        int pri = LEVEL(p);
	if(tx_state_[pri] != MAC_RTS) {
		discard(p, DROP_MAC_INVALID_STATE);
		return;
	}
	assert(pktRTS_[pri]);
	Packet::free(pktRTS_[pri]); pktRTS_[pri] = 0;

	assert(pktTx_[pri]);
	// debug
	//struct hdr_mac802_11 *mh = HDR_MAC802_11(pktTx_);
	//printf("(%d):recvCTS:pktTx_-%x,mac-subtype-%d & pktCTS_:%x\n",index_,pktTx_,mh->dh_fc.fc_subtype,p);
	
	mhSend_.stop();

	/*
	 * The successful reception of this CTS packet implies
	 * that our RTS was successful.  Hence, we can reset
	 * the Short Retry Count and the CW.
	 */
	//ssrc_ = 0;
	//rst_cw();
	//	if(mhDefer_.busy()) mhDefer_.stop();

	tx_resume();

	mac_log(p);
}



void
Mac802_11e::recvDATA(Packet *p)
{

        int pri = LEVEL(p);
	struct hdr_mac802_11e *dh = HDR_MAC802_11E(p);
	u_int32_t dst, src, size;
	struct hdr_cmn *ch = HDR_CMN(p);
	hdr_ip *iph = hdr_ip::access(p);
	

	dst = ETHER_ADDR(dh->dh_da);
	src = ETHER_ADDR(dh->dh_sa);
	size = ch->size();

	ch->size() -= phymib_.getHdrLen11();
	ch->num_forwards() += 1;

// printf("RecvData..... size=%d, id=%d, now=%lf, type=%s, %d\n", 
// ch->size(), ch->uid(), Scheduler::instance().clock(), packet_info.name(ch->ptype()), index_);

	/*
	 *  If we sent a CTS, clean up...
	 */
	if(dst != MAC_BROADCAST) {
		if(size >= macmib_.RTSThreshold) {
			if (tx_state_[pri] == MAC_CTS) {
				assert(pktCTRL_[pri]);
				Packet::free(pktCTRL_[pri]); pktCTRL_[pri] = 0;
				mhSend_.stop();
				/*
				 * Our CTS got through.
				 */
				printf("(%d): RECVING DATA!\n",index_);
				//ssrc_ = 0;
				//rst_cw();
			}
			else {
				discard(p, DROP_MAC_BUSY);
				printf("(%d)..discard DATA\n",index_);
				return;
			}
			sendACK(pri, src, ch->timestamp(), ch->uid());
			tx_resume(); 
		}
		/*
		 *  We did not send a CTS and there's no
		 *  room to buffer an ACK.
		 */
		else {
			if(pktCTRL_[pri]) {
				discard(p, DROP_MAC_BUSY);
				return;
			}


			
			sendACK(pri, src, ch->timestamp(), ch->uid());
			if(mhSend_.busy() == 0){
			    tx_resume();
			}
		}
	}


	
Tcl         &tcl = Tcl::instance();

    if( ch->ptype() == PT_CBR || ch->ptype() == PT_TCP || ch->ptype() == PT_UDP || 
	ch->ptype() == PT_EXP  )
    {
        switch ( index_ ) 
	{
	case 0:
// printf("RecvData..... src=%d, ip src=%d, size=%d, %d\n", src, ch->ipsrc(), ch->size(), index_);
		NumAP0 ++;
		break;
	case 1:
// printf("RecvData..... src=%d, ip src=%d, size=%d, %d\n", src, ch->ipsrc(), ch->size(), index_);
		NumAP1 ++;
		break;
	case 2:
		NumAP2 ++;
		break;
	case 3:
		NumAP3 ++;
		break;
	case 4:
		NumAP4 ++;
		break;
	case 5:
		NumAP5 ++;
		break;
	case 6:
		NumAP6 ++;
		break;
	case 7:
		NumAP7 ++;
		break;
	case 8:
		NumAP8 ++;
		break;
	case 9:
		NumAP9 ++;
		break;
	case 10:
		NumAP10 ++;
		break;
	case 11:
		NumAP11 ++;
		break;
	case 12:
		NumAP12 ++;
		break;
	case 13:
		NumAP13 ++;
		break;
	case 14:
		NumAP14 ++;
		break;
	case 15:
		NumAP15 ++;
		break;
	case 16:
		NumAP16 ++;
		break;
	case 17:
		NumAP17 ++;
		break;
	case 18:
		NumAP18 ++;

// printf("RecvData..... src=%d, ip src=%d, size=%d, %d\n", src, ch->ipsrc(), ch->size(), index_);
		switch ( ch->ipsrc() ) 
		{
		case 20:
// printf("RecvData..... NumFromNode0=%d, %d\n", NumFromNode0, index_);
			NumFromNode0 ++;
			break;
		case 21:
			NumFromNode1 ++;
			break;
		case 22:
			NumFromNode2 ++;
			break;
		case 23:
			NumFromNode3 ++;
			break;
		case 24:
			NumFromNode4 ++;
			break;
		case 25:
			NumFromNode5 ++;
			break;
		case 26:
			NumFromNode6 ++;
			break;
		case 27:
			NumFromNode7 ++;
			break;
		case 28:
			NumFromNode8 ++;
			break;
		case 29:
// printf("RecvData..... NumFromNode9=%d, %d\n", NumFromNode9, index_);
			NumFromNode9 ++;
			break;
		case 30:
			NumFromNode10 ++;
			break;
		case 31:
			NumFromNode11 ++;
			break;
		case 32:
			NumFromNode12 ++;
			break;
		case 33:
			NumFromNode13 ++;
			break;
		case 34:
			NumFromNode14 ++;
			break;
		case 35:
			NumFromNode15 ++;
			break;
		case 36:
			NumFromNode16 ++;
			break;
		case 37:
			NumFromNode17 ++;
			break;
		case 38:
			NumFromNode18 ++;
			break;
		case 39:
			NumFromNode19 ++;
			break;
		}
		break;
	case 19:
		NumAP19 ++;
		break;
	}
    }
	
        tcl.evalf("Mac/802_11e set NumRetryOut_ %d", num_of_retryout);

        tcl.evalf("Mac/802_11e set NumAP0_ %d", NumAP0);
        tcl.evalf("Mac/802_11e set NumAP1_ %d", NumAP1);
        tcl.evalf("Mac/802_11e set NumAP2_ %d", NumAP2);
        tcl.evalf("Mac/802_11e set NumAP3_ %d", NumAP3);
        tcl.evalf("Mac/802_11e set NumAP4_ %d", NumAP4);
        tcl.evalf("Mac/802_11e set NumAP5_ %d", NumAP5);
        tcl.evalf("Mac/802_11e set NumAP6_ %d", NumAP6);
        tcl.evalf("Mac/802_11e set NumAP7_ %d", NumAP7);
        tcl.evalf("Mac/802_11e set NumAP8_ %d", NumAP8);
        tcl.evalf("Mac/802_11e set NumAP9_ %d", NumAP9);
        tcl.evalf("Mac/802_11e set NumAP10_ %d", NumAP10);
        tcl.evalf("Mac/802_11e set NumAP11_ %d", NumAP11);
        tcl.evalf("Mac/802_11e set NumAP12_ %d", NumAP12);
        tcl.evalf("Mac/802_11e set NumAP13_ %d", NumAP13);
        tcl.evalf("Mac/802_11e set NumAP14_ %d", NumAP14);
        tcl.evalf("Mac/802_11e set NumAP15_ %d", NumAP15);
        tcl.evalf("Mac/802_11e set NumAP16_ %d", NumAP16);
        tcl.evalf("Mac/802_11e set NumAP17_ %d", NumAP17);
        tcl.evalf("Mac/802_11e set NumAP18_ %d", NumAP18);
        tcl.evalf("Mac/802_11e set NumAP19_ %d", NumAP19);
        tcl.evalf("Mac/802_11e set NumFromNode0_ %d", NumFromNode0);
        tcl.evalf("Mac/802_11e set NumFromNode1_ %d", NumFromNode1);
        tcl.evalf("Mac/802_11e set NumFromNode2_ %d", NumFromNode2);
        tcl.evalf("Mac/802_11e set NumFromNode3_ %d", NumFromNode3);
        tcl.evalf("Mac/802_11e set NumFromNode4_ %d", NumFromNode4);
        tcl.evalf("Mac/802_11e set NumFromNode5_ %d", NumFromNode5);
        tcl.evalf("Mac/802_11e set NumFromNode6_ %d", NumFromNode6);
        tcl.evalf("Mac/802_11e set NumFromNode7_ %d", NumFromNode7);
        tcl.evalf("Mac/802_11e set NumFromNode8_ %d", NumFromNode8);
        tcl.evalf("Mac/802_11e set NumFromNode9_ %d", NumFromNode9);
        tcl.evalf("Mac/802_11e set NumFromNode10_ %d", NumFromNode10);
        tcl.evalf("Mac/802_11e set NumFromNode11_ %d", NumFromNode11);
        tcl.evalf("Mac/802_11e set NumFromNode12_ %d", NumFromNode12);
        tcl.evalf("Mac/802_11e set NumFromNode13_ %d", NumFromNode13);
        tcl.evalf("Mac/802_11e set NumFromNode14_ %d", NumFromNode14);
        tcl.evalf("Mac/802_11e set NumFromNode15_ %d", NumFromNode15);
        tcl.evalf("Mac/802_11e set NumFromNode16_ %d", NumFromNode16);
        tcl.evalf("Mac/802_11e set NumFromNode17_ %d", NumFromNode17);
        tcl.evalf("Mac/802_11e set NumFromNode18_ %d", NumFromNode18);
        tcl.evalf("Mac/802_11e set NumFromNode19_ %d", NumFromNode19);

    if( ch->ptype() == PT_CBR || ch->ptype() == PT_TCP || ch->ptype() == PT_UDP || 
	ch->ptype() == PT_EXP  )
    {
	recvNBind ++;
	if ( ch->ptype() == PT_TCP ) THRind = (THRind + recvNBind * (ch->size()-60) * 8)/1000000 ;
	if ( ch->ptype() == PT_EXP ) THRind = (THRind + recvNBind * (ch->size()-20) * 8)/1000000 ;
// printf("transmit..... ipsrc=%d, size=%d, id=%d, now=%lf, type=%s, %d\n", 
// sd->ipsrc(), sd->size(), sd->uid(), Scheduler::instance().clock(), packet_info.name(sd->ptype()), index_);
// printf("ch size=%d, type=%s, \n", ch->size(), packet_info.name(ch->ptype()));

        tcl.evalf("Mac/802_11e set THRind_ %lf", THRind);
    }


	uptarget_->recv(p, (Handler*) 0);

}


void
Mac802_11e::recvACK(Packet *p)
{
// printf("Mac802_11e::recvACK\n"); 
        int pri = LEVEL(p);


	struct hdr_cmn *ch = HDR_CMN(p);
	struct hdr_mac802_11e *mh;
	if(tx_state_[pri] != MAC_SEND) {
	    discard(p, DROP_MAC_INVALID_STATE);
	return;
	}

	
	struct hdr_mac802_11e *dh = HDR_MAC802_11E(p);
	u_int32_t dst, src;
	dst = ETHER_ADDR(dh->dh_da);

// // //  Tianji Li, for Doug's ALgorithm
	if ( dst == 16 && pri == 1  ) {
  	    double intTime = Scheduler::instance().clock() - ch->timestamp();

	    ServTime = Wq *  ServTime + (1-Wq) * intTime;  // mean inter-leaving time

// // 	    ServTimeVarN = Wq * ServTimeVarN + (1-Wq) *  intTime * intTime;
// // 	    ServTimeVar = ServTimeVarN - ServTime * ServTime; // variance of inter-leaving time

	}
// // //  Tianji Li, for my ALgorithm




	mhSend_.stop();
	
	/*
	 * The successful reception of this ACK packet implies
	 * that our DATA transmission was successful.  Hence,
	 * we can reset the Short/Long Retry Count and the CW.
	 */
	if((u_int32_t) ch->size() <= macmib_.RTSThreshold)
		ssrc_[pri] = 0;
	else
		slrc_[pri] = 0;

	/* succesful transmission => give delay
	 * to Akaroa
	 */
	if(rtx_[pri]) rtx_[pri] = 0;
// 	double delay=Scheduler::instance().clock() - start_handle_[pri];
	#if AKAROA > 0
	if(AKAROA index_ > 0) {
	  AkObservation((6 * (index_ - 1)) + (pri + 4), delay);
	  start_handle_[pri]=0;
	}
	#endif


// printf("Mac802_11e::recvACK ... txop_limit_[%d]=%lf... %d\n", pri, txop_limit_[pri], index_);

	sending = 0;
	check_backoff_timer();
        /*
	 * Backoff before sending again.
	 */
	if(!cfb_ || ch->size() > macmib_.RTSThreshold) {
	  assert(mhBackoff_.backoff(pri) == 0);
	  rst_cw(pri);
	  mhBackoff_.start(pri, getCW(pri), is_idle());
	  assert(pktTx_[pri]);
	  Packet::free(pktTx_[pri]); pktTx_[pri] = 0;
	  tx_resume();

	}
	else{
	  // if this is the first packet in cfb, we must take its
	  // duration into account, too.
// printf("cfb_dur=%lf. %d\n", cfb_dur, index_);
	  if(cfb_dur < 0.000001) {
// 	  if(cfb_dur == 0) {
/*	      cfb_dur = txtime(pktTx_[pri])
		            + sifs_
		            + txtime(phymib_.getACKlen(), basicRate_);*/
		  if (txop_limit_[pri] >= 1.0) { 
		 	cfb_dur =1.0; 
// 		 	cout<<"cfb_dur:"<<cfb_dur<<", txop_limit_"<<txop_limit_[pri]<<"\n";
		  }
		  dl_sentcount=1;
		  mh = HDR_MAC802_11E(pktTx_[pri]);
		  dl_sent[dl_sentcount]=(u_int32_t)ETHER_ADDR(mh->dh_da);
	  }
	  pktRx_ = 0;
	  rx_resume();
	  assert(pktTx_[pri]);
	  Packet::free(pktTx_[pri]); pktTx_[pri] = 0;
	  cfb(pri);
	}
	mac_log(p);
}

void Mac802_11e::cfb(int pri)
{

  double timeout;
  struct hdr_mac802_11e *mh;
//   struct hdr_cmn *ch;
  int i, ok;
  Packet* p;
  
  // next packet out of queue
//   cout<<"packets in queue:"<<queue_->pri_[pri].getLen()<<"\n";

  ok=0;
  if(queue_->pri_[pri].getLen() > 0) {
	  if (txop_limit_[pri] >= 1.0) {
		  // look for packet with next distinct destination
		  for (i=0; i<queue_->pri_[pri].getLen() && ok==0 ; i++) {
			p = queue_->pri_[pri].q_->lookup(i);
			mh = HDR_MAC802_11E(p);
			ok=1;
		  }
		  if (ok>0) {
			queue_->pri_[pri].q_->remove(p);
		  }
	   } else {
/*		  ok=1;
		  p = queue_->pri_[pri].deque();*/
		  ok=0;
	   }
	}

      //Packet* p = queue_->pri_[pri].deque(); 
   if (ok>0) {
      // framing
      sendDATA(pri, p);
//       hdr_cmn *ch = HDR_CMN(pktTx_[pri]);
      mh = HDR_MAC802_11E(pktTx_[pri]);
      //cout<<"Mac "<<index_<<" in cfb(), pri "<<pri<<", cfb_bytes "<<cfb_bytes<<" + "<<ch->size()<<", cfb_maxbytes "<<cfb_maxbytes_<<"\n";
      if((u_int32_t)ETHER_ADDR(mh->dh_da) != MAC_BROADCAST) {

// printf("txop_limit_[pri]=%lf, %d\n", txop_limit_[pri], index_);

		if (txop_limit_[pri] < 1.0) {
			cfb_dur +=  sifs_ 
                        + txtime(pktTx_[pri])
			+ sifs_
                        + txtime(phymib_.getACKlen(), basicRate_);
/*			printf("TXOP can not be less than 1, exit...\n");
			printf("cfb_dur=%lf, txop_limit_[pri]=%lf...\n", cfb_dur, txop_limit_[pri]);
			printf("Use 'Mac/802_11e set cfb_ 0' in your TCL...\n");
			exit(0);*/
		} else {
			cfb_dur += 1.0;
// 			cout<<"cfb_dur:"<<cfb_dur<<", txop_limit_"<<txop_limit_[pri]<<"\n";
		}
		cfb_broadcast = 0;
      } else {
		if (txop_limit_[pri] < 1) {
	      		cfb_dur += sifs_  + txtime(pktTx_[pri]);
		} else {
			cfb_dur += 1.0;
			//cout<<"cfb_dur:"<<cfb_dur<<", txop_limit_"<<txop_limit_[pri]<<"\n";
		}
		cfb_broadcast = 1;
      }
  } else cfb_dur = txop_limit_[pri] + 1; 
 
// printf("aaaaaaaaa cfb_dur=%lf, txop_limit_[pri]=%lf, %d\n", cfb_dur, txop_limit_[pri], index_);
  if((cfb_dur <= txop_limit_[pri])) {
    // send
	if((u_int32_t)ETHER_ADDR(mh->dh_da) != MAC_BROADCAST) {
		timeout = txtime(pktTx_[pri])
				+ DSSS_EDCA_MaxPropagationDelay	
				+ sifs_
				+ txtime(phymib_.getACKlen(), basicRate_)
				+ DSSS_EDCA_MaxPropagationDelay;
		dl_sentcount++;
		mh = HDR_MAC802_11E(pktTx_[pri]);
		dl_sent[dl_sentcount]=(u_int32_t)ETHER_ADDR(mh->dh_da);
	
	} else timeout = txtime(pktTx_[pri]);    
	cfb_active = 1;
	mhSifs_.start(pri, sifs_);
  }
  else {
	cfb_dur = 0.0;
	cfb_broadcast = 0;
	assert(mhBackoff_.backoff(pri) == 0);
	rst_cw(pri);
	mhBackoff_.start(pri, getCW(pri), is_idle());
	tx_resume();
  }
}

// request parameters for each priority from the corresponding queues
double Mac802_11e::getAIFS(int pri)
{
    if(!AIFSset){
      levels = queue_->getLevels();
      for(int i = 0; i < levels; i++ ){
	slotnum = queue_->pri_[i].getAIFS();
	aifs_[i] = sifs_ + (slotnum * phymib_.getSlotTime());
	txop_limit_[i] = queue_->pri_[i].getTXOPLimit();
	//	    cout<<"Mac "<<index_<<", pri: "<<i<<", txop_limit:"<<txop_limit_[i]<<"\n";
      }
      AIFSset = 1;
    }
    return aifs_[pri];
}


int Mac802_11e::getCW(int level)
{
    if(!CWset){
	levels = queue_->getLevels();
	for(int i = 0; i < levels; i++ ){
	    cw_[i] = queue_->pri_[i].getCW_MIN();
	    cwmin_[i] = queue_->pri_[i].getCW_MIN(); 
	    cwmax_[i] = queue_->pri_[i].getCW_MAX(); 
	}
	CWset = 1;
    }

// printf("Mac802_11e::getCW..CW_min[%d]=%d, cw-max[%d]=%d,,,,,,%d\n", 
// level, queue_->pri_[level].getCW_MIN(), level, queue_->pri_[level].getCW_MAX(), index_);

    return cw_[level];
}

void
Mac802_11e::setQ(PriQ* priqueue){
printf("Mac802_11e::setQ\n");
    queue_ = priqueue;
}

inline void 
Mac802_11e::reset_eifs_nav() {
  if (eifs_nav_ > 0) {
    double now = Scheduler::instance().clock();
    
    assert(nav_ > now);
    assert(mhNav_.busy());
    
    mhNav_.stop();
    nav_ -= eifs_nav_;
    eifs_nav_ = 0.0;
    if (nav_ > now) {
      mhNav_.start(nav_ - now);
    } else {
      nav_ = now;
      check_backoff_timer();
    }
  }
}


bool Mac802_11e::inc_retryCounter(int pri) {
  u_int32_t *rcount, *thresh;
  struct hdr_cmn *ch = HDR_CMN(pktTx_[pri]);
  if((u_int32_t) ch->size() <= macmib_.RTSThreshold) {
    ssrc_[pri]++;
    rcount = &ssrc_[pri];
    thresh = &macmib_.ShortRetryLimit;
  }
  else {
    slrc_[pri]++;
    rcount = &slrc_[pri];
    thresh = &macmib_.LongRetryLimit;
  }
  if(*rcount > *thresh) {
    rtx_[pri] = 0;
    macmib_.FailedCount++;
    rst_cw(pri);
    discard(pktTx_[pri], DROP_MAC_RETRY_COUNT_EXCEEDED); pktTx_[pri] = 0;
    *rcount = 0;
    return 1;
  } else
     return 0;
}
